Package: ChIPDBData
Title: ChIP-seq Target Databases for TFEA.ChIP
Version: 1.0.0
Authors@R: c(person(given = "Yosra", family = "Berrouayel", email = "yosraberrouayel@gmail.com", role = c("aut", "cre"), comment = c(ORCID = "0000-0002-0768-5933")),
	     person(given = "Luis", family = "del Peso", email = "lpeso@iib.uam.es", role = c("aut"), comment = c(ORCID = "0000-0003-4014-5688")))
Description: Provides curated gene target databases derived from ChIP-seq datasets, formatted as ChIPDB objects for use with TFEA.ChIP.
License: GPL-3
Imports: ExperimentHub
Suggests: knitr, rmarkdown, BiocStyle, AnnotationHub, TFEA.ChIP,
        DESeq2, testthat (>= 3.0.0)
biocViews: ExperimentData, ExperimentHub, Homo_sapiens_Data, ENCODE,
        SequencingData
VignetteEngine: knitr::rmarkdown
VignetteBuilder: knitr
URL: https://github.com/yberda/ChIPDBData
BugReports: https://github.com/yberda/ChIPDBData/issues
Encoding: UTF-8
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.3.2
Config/testthat/edition: 3
git_url: https://git.bioconductor.org/packages/ChIPDBData
git_branch: RELEASE_3_22
git_last_commit: 5162621
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-10-30
NeedsCompilation: no
Packaged: 2025-10-30 15:15:57 UTC; biocbuild
Author: Yosra Berrouayel [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-0768-5933>),
  Luis del Peso [aut] (ORCID: <https://orcid.org/0000-0003-4014-5688>)
Maintainer: Yosra Berrouayel <yosraberrouayel@gmail.com>

#  ChIPDBData

`ChIPDBData` is a Bioconductor data package providing preprocessed ChIP-seq datasets for transcription factor enrichment analyses with TFEA.ChIP.

## Installation

You can install the package from Bioconductor with:

```r
if (!require("BiocManager", quietly = TRUE))
    install.packages("BiocManager")
BiocManager::install("ChIPDBData")
```

## Usage

Load a ChIPDB dataset from the ChIPDBData package:

```r
library(ChIPDBData)

# For example, load the ENCODE dataset filtered by depth >= 300
ChIPDB <- getChIPDB("ENCODE_rE2G_300depth")
```
Once loaded, the datasets can be used to perform transcription factor enrichment analysis with TFEA.ChIP. Begin by importing your differential expression data and defining the regulated and control gene sets. Then, run the enrichment analysis as follows:

```r
# Load and preprocess differential expression table
library(TFEA.ChIP)
data('hypoxia_DESeq')
hypoxia_table <- preprocessInputData(hypoxia_DESeq)

# Define gene sets
Genes.Upreg <- Select_genes(hypoxia_table, min_LFC = 1)
Genes.Control <- Select_genes(hypoxia_table,
  min_pval = 0.5, max_pval = 1,
  min_LFC = -0.25, max_LFC = 0.25
)

# Run TF enrichment
CM_list <- contingency_matrix(Genes.Upreg, Genes.Control)
results <- getCMstats(CM_list)

# Display results
head(results)
```

main.data <- data.frame(
  Title = c(
    "ENCODE rE2G complete",
    "ENCODE rE2G greater than 0.25 score",
    "ENCODE rE2G greater than 0.5 score",
    "ENCODE rE2G greater than 0.75 score",
    "ENCODE rE2G greater than 50 depth",
    "ENCODE rE2G greater than 100 depth",
    "ENCODE rE2G greater than 200 depth",
    "ENCODE rE2G greater than 300 depth",
    "CREdb",
    "GeneHancer"
  ),
  
  Description = paste(
    "ChIPDB object for TFEA.ChIP.",
    c(
      rep("Processed rE2G dataset.", 8),
      "Comprehensive database of Cis-Regulatory Elements.",
      "Genome-Wide Integration of Enhancers and Target Genes."
    )
  ),
  
  BiocVersion = rep("3.22", 10), 
  Genome = rep("GRCh38", 10),
  SourceType = rep("RDA", 10),
  
  SourceUrl = c(
    rep("https://zenodo.org/records/15667485", 10)
  ),
  
  SourceVersion = rep("2024", 10),
  Species = rep("Homo sapiens", 10),
  TaxonomyId = rep("9606", 10),
  Coordinate_1_based = rep(TRUE, 10),
  
  DataProvider = c(
    rep("ENCODE", 8),
    "CREDB",
    "GeneHancer"
  ),
  
  RDataClass = rep("list", 10),
  DispatchClass = rep("Rda", 10),
  
  Location_Prefix =  c(
    rep("https://zenodo.org/", 10)
  ),
  
  RDataPath = c(
    "records/15667485/files/encode_re2g_object_hg38.rda",
    "records/15667485/files/encode_re2g-25_object_hg38.rda",
    "records/15667485/files/encode_re2g-5_object_hg38.rda",
    "records/15667485/files/encode_re2g-75_object_hg38.rda",
    "records/15667485/files/encode_re2g-50depth_object_hg38.rda",
    "records/15667485/files/encode_re2g-100depth_object_hg38.rda",
    "records/15667485/files/encode_re2g-200depth_object_hg38.rda",
    "records/15667485/files/encode_re2g-300depth_object_hg38.rda",
    "records/15667485/files/credb_object_hg38.rda",
    "records/15667485/files/genehancer_object_hg38.rda"
  ),
  
  Tags = c(
    rep("ChIP-seq,TF,ENCODE", 8),
    "ChIP-seq,TF,CRE",
    "ChIP-seq,TF,Enhancer"
  ),
  
  Maintainer = rep("Yosra Berrouayel <yosraberrouayel@gmail.com>", 10),
  
  stringsAsFactors = FALSE
)

# Save to file
write.csv(main.data, file = "../extdata/metadata.csv", row.names = FALSE)

## ---------------------------------------------------------------------------
## Script to generate the ChIPDBs object included in this package
##
## The ChIPDB object contains transcription factor (TF)–target associations
## inferred from ChIP-seq datasets in ReMap2022 by linking peaks to candidate 
## target genes through cis-regulatory element (CRE)–gene connections.
##
## Data sources:
## - ReMap2022 (ChIP-seq binding sites, see: https://remap2022.univ-amu.fr/)
## - ENCODE rE2G (regulatory element-to-gene links; cell-type specific)
## - CREdb (curated CRE–gene links; used for generalization across cell types)
## - GeneHancer (integrated enhancer–gene links from multiple sources)
##
## Processing summary:
## 1. Load CRE–gene links from ENCODE rE2G, CREdb, or GeneHancer.
##    - To avoid cell-type specificity in ENCODE rE2G, we generalized 
##      the links. We kept only high-confidence CRE–gene pairs, either:
##        a) with a high associated rE2G score, or
##        b) supported in multiple cell types (“depth” criterion).
##    - Full details of the strategy are described in:
##      Yosra Berrouayel and Luis del Peso, bioRxiv 2025.07.28.667192v1
##      https://www.biorxiv.org/content/10.1101/2025.07.28.667192v1
##
## 2. Load ReMap2022 ChIP-seq peak sets.
##
## 3. For each ChIP-seq dataset, check overlap between peaks and CREs. If a
##    peak overlaps a CRE, assign the linked gene(s) as potential targets
##    of the corresponding TF experiment. Result: ChIPDB, a list mapping each
##    TF ChIP-seq experiment to its inferred targets.
##    
## 4. Save ChIPDB as an .rda object for package distribution.
##
## ---------------------------------------------------------------------------

library(GenomicRanges)
library(TFEA.ChIP)

# Load ReMap2022 ChIP-seq peaks (list of GRanges objects)
load("data/remap.rdata")

# Load CRE–gene ranges from ENCODE rE2G, CREdb or GeneHancer (GRanges object)
load("data/cre_ranges.rdata")

# Generate the ChIPDB object using makeChIPGeneDB fx (TFEA.ChIP package)
ChIPDB <- makeChIPGeneDB(cre_ranges, remap)

# Save for package inclusion
save(ChIPDB, file = "data/ChIPDB.rda")

#' ChIPDBData: A package for curated ChIP-seq TF target databases
#'
#' The `ChIPDBData` package provides curated ChIP-seq transcription factor
#'  target databases designed for use with TFEA.ChIP
#'
#' @section Package contents:
#' - Functions provided: \code{getChIPDB} (for loading the dataset)
#'
#' @docType package
#' @name ChIPDBData
#' @keywords internal
"_PACKAGE"

## usethis namespace: start
## usethis namespace: end
NULL

## ----setup, include=FALSE-----------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
library(TFEA.ChIP)

## ----lib-install, message=FALSE, eval=FALSE-----------------------------------
# if (!require("BiocManager", quietly = TRUE))
#     install.packages("BiocManager")
# BiocManager::install("ChIPDBData")

## ----load-lib, message=FALSE, warning=FALSE, cache=FALSE----------------------
library(ChIPDBData)

## ----load-chipdb-eh-----------------------------------------------------------
library(ExperimentHub)

eh <- ExperimentHub()
dbs <- query(eh, "ChIPDBData")
dbs

# Example: Load ENCODE rE2G300d
ChIPDB <- dbs[["EH9854"]]  # IMPORTANT: Assign to 'ChIPDB'

## ----load-chipdb--------------------------------------------------------------
# Load the ENCODE dataset filtered by depth >= 300
ChIPDB <- getChIPDB("ENCODE_rE2G_300depth")

## ----explore-db---------------------------------------------------------------
# List names of the top-level elements
names(ChIPDB)

# Preview the first few Entrez IDs
ChIPDB[[1]][1:5]

# View names of ChIP-seq experiments
names(ChIPDB[[2]])[1:3]

# Show gene indices for the first experiment
ChIPDB[[2]][[1]][1:5]

# Get actual gene IDs from those indices
ChIPDB[[1]][ ChIPDB[[2]][[1]][1:5] ]

## ----eval=TRUE----------------------------------------------------------------
# Load and preprocess differential expression table
data('hypoxia_DESeq')
hypoxia_table <- preprocessInputData(hypoxia_DESeq)

# Define gene sets
Genes.Upreg <- Select_genes(hypoxia_table, min_LFC = 1)
Genes.Control <- Select_genes(hypoxia_table,
  min_pval = 0.5, max_pval = 1,
  min_LFC = -0.25, max_LFC = 0.25
)

# Run TF enrichment
CM_list <- contingency_matrix(Genes.Upreg, Genes.Control)
results <- getCMstats(CM_list)

# Display results
head(results)

## ----session-info-------------------------------------------------------------
sessionInfo()

#' Retrieve ChIPDB dataset from ExperimentHub
#'
#' This function fetches ChIPDB objects (lists of transcription factor–target 
#' gene associations) for use with the TFEA.ChIP package. Available datasets 
#' include ENCODE, CREDB, and GeneHancer-derived collections.
#'
#' @param name A character string naming the dataset to retrieve.
#'             Options:   "ENCODE_rE2G", "ENCODE_rE2G_25score", "ENCODE_rE2G_50score",
#'             "ENCODE_rE2G_75score", "ENCODE_rE2G_50depth", "ENCODE_rE2G_100depth",
#'             "ENCODE_rE2G_200depth", "ENCODE_rE2G_300depth",
#'             "CREdb", "GeneHancer".
#' @return A list object of class ChIPDB containing transcription factor–target gene mappings.
#' @export
#'
#' @examples
#' ChIPDB <- getChIPDB("ENCODE_rE2G_300depth")
getChIPDB <- function(name = c(
  "ENCODE_rE2G",
  "ENCODE_rE2G_25score",
  "ENCODE_rE2G_50score",
  "ENCODE_rE2G_75score",
  "ENCODE_rE2G_50depth",
  "ENCODE_rE2G_100depth",
  "ENCODE_rE2G_200depth",
  "ENCODE_rE2G_300depth",
  "CREdb",
  "GeneHancer"
)) {
  name <- match.arg(name)

  # Mapping from user-friendly names to EH IDs
  eh_map <- list(
    ENCODE_rE2G          = "EH9847",
    ENCODE_rE2G_25score  = "EH9848",
    ENCODE_rE2G_50score  = "EH9849",
    ENCODE_rE2G_75score  = "EH9850",
    ENCODE_rE2G_50depth  = "EH9851",
    ENCODE_rE2G_100depth = "EH9852",
    ENCODE_rE2G_200depth = "EH9853",
    ENCODE_rE2G_300depth = "EH9854",
    CREdb                = "EH9855",
    GeneHancer           = "EH9856"
  )

  eh_id <- eh_map[[name]]

  if (is.null(eh_id)) {
    stop("Invalid dataset name. See ?getChIPDB for allowed options.")
  }

  eh <- ExperimentHub::ExperimentHub()

  tryCatch({
    obj <- eh[[eh_id]]
    return(obj)
  }, error = function(e) {
    stop("Failed to retrieve the dataset from ExperimentHub. Please ensure your internet connection is active and that the dataset exists.\n\n", conditionMessage(e))
  })
}

test_that("test DB loading", {

    ChIPDB <- ChIPDBData::getChIPDB("ENCODE_rE2G_300depth")
    expect_equal(length(ChIPDB), 2)
    
    # first element is a vector
    expect_true(is.vector(ChIPDB[[1]]))
    
    # second element is a list
    expect_true(is.list(ChIPDB[[2]]))
    
    # edge case: wrong dataset name
    
})

test_that("test with edge case: wrong dataset name", {
    expect_error(ChIPDBData::getChIPDB("ENCODE_rE2G_1000depth"))
})

---
title: "Using ChIPDBData with TFEA.ChIP"
author: "Yosra Berrouayel and Luis del Peso"
date: "`r Sys.Date()`"
output: BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{Using ChIPDBData}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
library(TFEA.ChIP)
```

# Overview

The `ChIPDBData` package provides curated ChIP-seq transcription factor target databases designed for use with `r Biocpkg("TFEA.ChIP")`.

Each dataset contains a collection of ChIP-seq experiments (e.g., from ENCODE) along with their associated gene targets. These datasets are structured as **`ChIPDB` list objects**, and can be accessed either manually or via the `getChIPDB()` function.

**Important:** When loading any dataset, make sure it is assigned to an object named `ChIPDB`. This is crucial, as `TFEA.ChIP` looks for a globally defined object called `ChIPDB` and will **not recognize** it under any other name.

# Installation

To install the package, start R and enter:

```{r lib-install, message=FALSE, eval=FALSE}
if (!require("BiocManager", quietly = TRUE))
    install.packages("BiocManager")
BiocManager::install("ChIPDBData")
```

Once `ChIPDBData` is installed, it can be loaded with the following command:

```{r load-lib, message=FALSE, warning=FALSE, cache=FALSE}
library(ChIPDBData)
```

# Available Datasets

The following datasets are currently available in the `ChIPDBData` package:

- ENCODE rE2G (complete)
- ENCODE rE2G subsets filtered by:
    - Score thresholds: 0.25, 0.5, 0.75
    - Depth thresholds: 50, 100, 200, 300
- CREdb
- GeneHancer

These can be accessed via the **ExperimentHub** interface:

```{r load-chipdb-eh}
library(ExperimentHub)

eh <- ExperimentHub()
dbs <- query(eh, "ChIPDBData")
dbs

# Example: Load ENCODE rE2G300d
ChIPDB <- dbs[["EH9854"]]  # IMPORTANT: Assign to 'ChIPDB'
```

Alternatively, you can retrieve datasets programmatically using `getChIPDB()` with any of the following identifiers: "ENCODE_rE2G", "ENCODE_rE2G_25score", "ENCODE_rE2G_50score", "ENCODE_rE2G_75score", "ENCODE_rE2G_50depth", "ENCODE_rE2G_100depth", "ENCODE_rE2G_200depth", "ENCODE_rE2G_300depth", "CREdb" or "GeneHancer".

For example:

```{r load-chipdb}
# Load the ENCODE dataset filtered by depth >= 300
ChIPDB <- getChIPDB("ENCODE_rE2G_300depth")
```

A `ChIPDB` object is a named list with two main components:

1. A **character vector of Entrez Gene IDs**, representing the universe of possible targets.
2. A **named list of ChIP-seq experiments**, where each element is a vector of integer indices pointing to the genes in component 1. Each entry represents the gene targets of a transcription factor in a specific experiment.

Exploring the structure:

```{r explore-db}
# List names of the top-level elements
names(ChIPDB)

# Preview the first few Entrez IDs
ChIPDB[[1]][1:5]

# View names of ChIP-seq experiments
names(ChIPDB[[2]])[1:3]

# Show gene indices for the first experiment
ChIPDB[[2]][[1]][1:5]

# Get actual gene IDs from those indices
ChIPDB[[1]][ ChIPDB[[2]][[1]][1:5] ]
```

# Integration with `TFEA.ChIP`

To perform transcription factor enrichment analysis, start by loading your differential expression data and defining the regulated and control gene sets. Ensure that your ChIP-seq database is loaded and assigned to `ChIPDB`. The `TFEA.ChIP` functions will automatically use this object for analysis.

**Important:** Make sure to load `ChIPDB` after running `library(TFEA.CHIP)`. Otherwise, the package's default database (a limited subset from GeneHancer) will overwrite it.

```{r eval=TRUE}
# Load and preprocess differential expression table
data('hypoxia_DESeq')
hypoxia_table <- preprocessInputData(hypoxia_DESeq)

# Define gene sets
Genes.Upreg <- Select_genes(hypoxia_table, min_LFC = 1)
Genes.Control <- Select_genes(hypoxia_table,
  min_pval = 0.5, max_pval = 1,
  min_LFC = -0.25, max_LFC = 0.25
)

# Run TF enrichment
CM_list <- contingency_matrix(Genes.Upreg, Genes.Control)
results <- getCMstats(CM_list)

# Display results
head(results)
```

# Session Info

```{r session-info}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ChIPDBData.R
\name{getChIPDB}
\alias{getChIPDB}
\title{Retrieve ChIPDB dataset from ExperimentHub}
\usage{
getChIPDB(
  name = c("ENCODE_rE2G", "ENCODE_rE2G_25score", "ENCODE_rE2G_50score",
    "ENCODE_rE2G_75score", "ENCODE_rE2G_50depth", "ENCODE_rE2G_100depth",
    "ENCODE_rE2G_200depth", "ENCODE_rE2G_300depth", "CREdb", "GeneHancer")
)
}
\arguments{
\item{name}{A character string naming the dataset to retrieve.
Options:   "ENCODE_rE2G", "ENCODE_rE2G_25score", "ENCODE_rE2G_50score",
"ENCODE_rE2G_75score", "ENCODE_rE2G_50depth", "ENCODE_rE2G_100depth",
"ENCODE_rE2G_200depth", "ENCODE_rE2G_300depth",
"CREdb", "GeneHancer".}
}
\value{
A list object of class ChIPDB containing transcription factor–target gene mappings.
}
\description{
This function fetches ChIPDB objects (lists of transcription factor–target
gene associations) for use with the TFEA.ChIP package. Available datasets
include ENCODE, CREDB, and GeneHancer-derived collections.
}
\examples{
ChIPDB <- getChIPDB("ENCODE_rE2G_300depth")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ChIPDBData-package.R
\docType{package}
\name{ChIPDBData}
\alias{ChIPDBData-package}
\alias{ChIPDBData}
\title{ChIPDBData: A package for curated ChIP-seq TF target databases}
\description{
The \code{ChIPDBData} package provides curated ChIP-seq transcription factor
target databases designed for use with TFEA.ChIP
}
\section{Package contents}{

\itemize{
\item Functions provided: \code{getChIPDB} (for loading the dataset)
}
}

\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/yberda/ChIPDBData}
  \item Report bugs at \url{https://github.com/yberda/ChIPDBData/issues}
}

}
\author{
\strong{Maintainer}: Yosra Berrouayel \email{yosraberrouayel@gmail.com} (\href{https://orcid.org/0000-0002-0768-5933}{ORCID})

Authors:
\itemize{
  \item Luis del Peso \email{lpeso@iib.uam.es} (\href{https://orcid.org/0000-0003-4014-5688}{ORCID})
}

}
\keyword{internal}
